#![cfg_attr(nightly, feature(never_type))] 

#![allow(dead_code)]

use cfg_if::cfg_if;
use lazy_static::lazy_static;
use futures::prelude::*;

#[allow(unused_imports)]
use color_eyre::{
    eyre::{
	self,
	eyre,
	WrapErr as _,
    },
    SectionExt as _, Help as _,
};

mod util;
mod args;

cfg_if!{
    if #[cfg(nightly)] {
	type Never = !;
    } else {
	type Never = std::convert::Infallible;
    }
}

type Pointer = *const Never;

fn install() -> eyre::Result<()>
{
    color_eyre::install()?;

    Ok(())
}

async fn process(file: String)
{
    println!(" -> {}", file);
    //TODO: Process this file
}

async fn begin() -> eyre::Result<i32>
{
    install()?;

    if args::process(process).await
        .wrap_err(eyre!("One or more child workers failed to complete successfully"))? == 0 {
	args::usage();
    }
    Ok(0)
}

#[tokio::main]
async fn main() -> eyre::Result<()>
{
    std::process::exit(match begin().await {
	Ok(0) => return Ok(()),
	Err(err) => {
	    eprintln!("\nexited with error: {}", err);
	    return Err(err)
		.wrap_err(eyre!("Fatal error"));
	},
	Ok(v) => v
    })
}
